var SMSs = "1/3-19069+05056906+28296031410120710101503612+28108060810121060101500218+28059051410120930101400524+280410511101310600014002-19285+05054006+28080101410121050001\n2/3000212+28094091010121050000900218+28061071410111060101400224+280540709101310600014002-18854+05053706+28296031410120710101503612+28108060810121060101500218+28\n3/3059051410120930101400524+280410511101310600014002";
var myQueue = new Queue();
var SMStr, offset, retStr;

//Called when application is started.
function OnStart()
{
	lay = app.CreateLayout( "Linear", "FillXY,VCenter" );
	edt = app.CreateTextEdit( "CB1", 0.8 ); 

	//Create a text control to show data log.
	txt = app.CreateText("", 0.9, 0.9, "Multiline, Left");
	txt.SetTextColor( "#ffffffff" );
	lay.AddChild(txt);

	//Add main layout to app.
	app.AddLayout(lay);
	//Create array to hold log messages.
	log = new Array();
	getSMSs(); // Normally coming automatically and stored using FIFO into myQueue
	decodeSMSs();
}

function decodeSMSs() {
    var SMStrLen, sms = [];
    var tmpStr, number, SMSnumber = myQueue.size();
    for(count = 0; count < SMSnumber; ++count) {
        tmpStr = myQueue.pull();
        number = tmpStr.substr(0,3).split("/");
        sms[number[0]] = tmpStr.substr(3,157);
        // Log(number[0] + "/" + SMSnumber);
    }
    if (number[1] != SMSnumber) {
        Log("Wrong number of SMS");
        return;
    }
    // All SMSs were received
    SMStr = "";
    retStr = "";
    offset = 0;
    for(count = 1; count <= SMSnumber; ++count) {
        SMStr += sms[count];
    }
    SMStrLen = SMStr.length;
    //Log(SMStr);
    while(offset < SMStrLen) {
        getCoordinates();
        while(true) {
            getValues(); 
            tmpStr = SMStr.substr(offset, 1);
            if(offset == SMStrLen || tmpStr == "-" || tmpStr == "+") {
                break;
            }
        }
    }
    Log(retStr);
    //Log(offset);
}

function getValues() {
	retStr += SMStr.substr(offset, 2); // Time
	offset += 2;
	retStr += "," + SMStr.substr(offset, 3); // Air temp
	offset += 3;
	retStr += "," + SMStr.substr(offset, 3); // Wind dir.
	offset += 3;
	retStr += "," + SMStr.substr(offset, 2); // Wind speed
	offset += 2;
	retStr += "," + SMStr.substr(offset, 2); // Wind gust
	offset += 2;
	retStr += "," + SMStr.substr(offset, 4); // Pressure
	offset += 4;
	retStr += "," + SMStr.substr(offset, 2); // Visibility
	offset += 2;
	retStr += "," + SMStr.substr(offset, 1); // Cloud cover
	offset += 1;
	retStr += "," + SMStr.substr(offset, 3); // Wave height
	offset += 3;
	retStr += "," + SMStr.substr(offset, 3); // Swell dir.
	offset += 3;
	retStr += "," + SMStr.substr(offset, 2); // Code
	offset += 2;
	retStr += "\n";
}

function getCoordinates() {
    retStr += parseInt(SMStr.substr(offset, 6)) / 1000;
    offset += 6;
    retStr += "," + parseInt(SMStr.substr(offset, 7)) / 1000;
    offset += 7;
	retStr += "\n";
}

function getSMSs() {
	var count, param = SMSs.split("\n");
	var SMSnumber = param.length;
	for (count = 0; count < SMSnumber; ++count) {
	    myQueue.push(param[count]);
	}
}

//Add messages to log.
function Log(msg) {
	if (txt.GetLineTop(txt.GetLineCount()) >= 0.8) log.shift();
	log.push(msg + "\n");
	txt.SetText(log.join(""));
}

// Queue methods
function Queue() {
    this.data = [];
}
Queue.prototype.push = function(record) {
  return this.data.unshift(record);
}
Queue.prototype.pull = function() {
  return this.data.pop();
}
Queue.prototype.size = function() {
  return this.data.length;
}
